//#include <lcd.h>
sbit rs at RD4_bit;
sbit rw at RD5_bit;
sbit en at RD6_bit;
#define rs_out      {NOT_RBPU_bit=0; TRISD4_bit=0; rs=0;}
#define rw_out      {NOT_RBPU_bit=0; TRISD5_bit=0; rw=0;}
#define en_out      {TRISD6_bit=0; en=0;}
#define Dlcd_Config {TRISC=0; PORTC=0;}
unsigned char Sec, Min, Hour, Day, Date, Month, Year, s1,s2,m1,m2,h1,h2,dy1,dy2,dt1,dt2,mn1,mn2,yr1,yr2;
unsigned char *l[]={"SUN","MON","TUE","WED","THU","FRI","SAT"};
unsigned char lcd_thresold=1, count, x, n=0, press, line=1, flg=0, tempB;

//---------------------------------FUNCTION DECLARATION--------------//
void Delay(unsigned int);
void LCDInit();
void writedata(unsigned char);
void writecmd(unsigned char);
void load(unsigned char);
void store(unsigned char);
void LCD_cursor(unsigned char, unsigned char);
void switch_press(unsigned char);
void check();

struct use
{
 unsigned char p;
};


//--------------------------------------INTERRUPT----------------------//

void interrupt()
{
     if(RBIF_bit==1) { flg.B0= 1; press=PORTB; }
     if((INTF_bit==1) &&(RBIF_bit==0)) { flg.B1=1;}
     RBIF_bit=0;
     INTF_bit=0;
     switch_press(press);                                            // Here I get the main problem. I cannot call this function. This is the main
	                                                                 // part of my switch response function. 
     PORTD=0xFF;
}

//--------------------------------------MAIN----------------------//

void Main()
{
 unsigned char temp;
  struct use flagvalue;
  struct use groomvalue;
  flagvalue.p=5;
  groomvalue.p=6;
//unsigned char list[]= {s1,s2};
  TRISD=0;
  PORTD=0;
 // PORTD=0xFF;
  s1=1; s2=2;
  s1=s1|0x30;
  s2=s2|0x30;
 /*
   m1=Min&0xF0; m2=Min&0x0F;
  h1=Hour&0xF0; h2=Hour&0x0F;
 */
  LCDInit();
  LCD_cursor(1,7);
  writedata(s1);
  writedata(s2);
  writedata(0x3A);
  writecmd(0x0E);

//TRISB = 0xF0;                                 // mask upper 4 bits(PB4-PB7) for interrupt on change. the lower bits used as the output.
PORTB=0xF0;                                   // OR PORTB=0xFF;
//NOT_RBPU_bit=0;
INTCON=0;
GIE_bit=1;
RBIE_bit=1;
RBIF_bit=0;
    while(1)
    {  
      if(flg.B0==1) PORTD=0x0F;
      if(flg.B1==1) PORTD=1;
     }
}


//--------------------------------SWITCH_PRESS---------------------------//

//#pragma inter 0xA5
void switch_press(unsigned char tempB)
{

loop1:
      switch(tempB)
      {
          case(0x0E):
          {
            store(n);
            n++; 
			load(n);
            LCD_cursor(line,lcd_thresold);
            writecmd(0x0F);       // cursor Blink
            PORTD=n;
            goto lo;
          }

          case(0x0D):
          {
             writecmd(0x0F);
             writecmd(0x0C);   //cursor off
             if(n==1) { if(x<2) x++; }
             if(n==2) { if(x<3) x++; }
             x++;
                  x=x|0x30;
                  writedata(x);
                  writecmd(0x10); //cursor left
                  writecmd(0x0F); //Blink
                  while(1);
            //writecmd(command to shift cursor left 1 position);
            //writecmd(command for cursor blinking);
            goto lo;
          }

          case(0x0B):
          {  writecmd(0x0F); //erase
           //writecmd(command to cursor off);
            x--;
            //LCD_Pout(line,lcd_thresold,x);
            //writecmd(command to shift cursor left 1 position);
            //writecmd(command for cursor blinking);
            goto lo;
          }

          case(0x07):
          { 
            writecmd(0x0F); //erase
            check();
            flg|=0;
            break;
            //goto lo;
          }
          break;
       }  // switch
	   if (tempB==0x07) goto loop3;
 loop2:  
	   press=PORTB;
       press|=0xF0;
       if(!(press==0xF0)) goto loop2;
       goto loop1;
 loop3:
 }

//--------------------------------------DELAY-------------------------------//

void Delay(unsigned int tm)
{
 unsigned int p;
 for(p=0;p<tm;p++);
}

//--------------------------------------LOAD-------------------------------//

 void load(unsigned char l)
{
 if(l==0);
 else if(l==1) { x=s1; lcd_thresold=7;  line=1;}
 else if(l==2) { x=s2; lcd_thresold=8;  line=1;}
 else if(l==3) { x=m1; lcd_thresold=10; line=1;}
 else if(l==4) { x=m2; lcd_thresold=11; line=1;}
 else if(l==5) { x=h1; lcd_thresold=13; line=1;}
 else if(l==6) { x=h2; lcd_thresold=14; line=1;}
}

//--------------------------------------STORE-------------------------------//

void store(unsigned char l)
{
 if(l==0);
 else if(l==1) s1=x;
 else if(l==2) s2=x;
 else if(l==3) m1=x;
 else if(l==4) m2=x;
 else if(l==5) h1=x;
 else if(l==6) h2=x;
}

//--------------------------------------WRITECMD-------------------------------//

void writecmd(unsigned char a)
{
     Delay(200);
     TRISA=0;
     TRISC=0;
     rs=0;
     rw=0;
     PORTC=a;
     en=1;
     Delay(2);
     en=0;
}

//--------------------------------------WRITEDATA-------------------------------//

void writedata(unsigned char c)
{
     TRISA=0;
     TRISC=0;
     Delay(200);
     rs=1;
     rw=0;
     PORTC=c;
     en=1;
     Delay(2);
     en=0;
}

//--------------------------------------LCDINIT-------------------------------//

void LCDInit()
{
     rs_out; rw_out; en_out;
     Dlcd_Config;
     Delay(100);
     writecmd(0x38);
     Delay(100);
     writecmd(0x01);
      Delay(100);
     writecmd(0x0c);
}

//--------------------------------------LCD_CURSOR-------------------------------//

void LCD_cursor(unsigned char row, unsigned char column)
{
   unsigned char t;
     if(row==1)
     {
      writecmd(0x80);
      for(t=0;t<column;t++)
      {
      Delay(100);
      writecmd(0x14);
      }
     }
     if(row==2)
     {
      writecmd(0xC0);
      for(t=0;t<column;t++)
      {
      Delay(100);
      writecmd(0x14);
      }
     }
}

void check()
{

}